
/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package jp.co.intra_mart.product.eb.sample.simplesales.data.dm;

import java.util.List;
import jp.co.intra_mart.framework.base.data.DataConnector;
import jp.co.intra_mart.framework.system.exception.SystemException;
import jp.co.intra_mart.product.eb.model.dao.OrderByClause;

/**
 * <!-- begin-user-doc -->
 * 
 * このクラスを取得するためのgetDAOメソッド ログイングループデータソース用
 * (jp.co.intra_mart.product.eb.sample.simplesales.data.dm.EbSCustomerDao)
 * getDAO("jp.co.intra_mart.product.eb.sample.simplesales.conf.simplesales" ,
 * "dm.eb_s_customer" , loginGroupId )
 * 
 * システムデータソース用
 * (jp.co.intra_mart.product.eb.sample.simplesales.data.dm.EbSCustomerDao)
 * getDAO("jp.co.intra_mart.product.eb.sample.simplesales.conf.simplesales_sys"
 * , "dm.eb_s_customer" , connectId )
 * 
 * <!-- end-user-doc -->
 * 
 * @generated intra-mart e Bulider
 */
public interface EbSCustomerDao {

	/**
	 * EB_S_CUSTOMER のレコード追加。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params customerName 得意先名
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @return 登録された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int addEbSCustomer(String customerCd, String customerName,
			String insertUserId, String recordUserId,
			java.util.Date insertDate, java.util.Date recordDate)
			throws SystemException;

	public static final String GET_EB_SCUSTOMER_DEFAULT_ORDER_BY_CLAUSE = "";

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @return 条件に一致したレコード
	 *         ※複数のレコードが一致した場合、先頭のレコードを返却。またDAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *         BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer getEbSCustomer(
			String customerCd) throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer getEbSCustomer(
			String customerCd, OrderByClause orderByClause)
			throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer getEbSCustomer(
			String customerCd, String orderByClause) throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSCustomer(String customerCd)
			throws SystemException;

	public static final String GET_EB_SCUSTOMER_LIST_DEFAULT_ORDER_BY_CLAUSE = "";

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList()
			throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			OrderByClause orderByClause) throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			String orderByClause) throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSCustomer>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			int offset, int limit) throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSCustomer>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			OrderByClause orderByClause, int offset, int limit)
			throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSCustomer>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			String orderByClause, int offset, int limit) throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードの件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public long countGetEbSCustomerList() throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSCustomerList() throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSCustomer(String customerCd) throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSCustomers() throws SystemException;

	/**
	 * EB_S_CUSTOMER のレコード更新。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * 
	 * @params customerName 得意先名
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params customerCd 得意先コード
	 * @return 更新された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int updateEbSCustomer(String customerName, String insertUserId,
			String recordUserId, java.util.Date insertDate,
			java.util.Date recordDate, String customerCd)
			throws SystemException;
}
