
/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package jp.co.intra_mart.product.eb.sample.simplesales.data.dm;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import jp.co.intra_mart.framework.base.data.DataConnectException;
import jp.co.intra_mart.framework.base.data.DataConnector;
import jp.co.intra_mart.framework.base.data.LoginGroupDBDAO;
import jp.co.intra_mart.framework.system.exception.SystemException;
import jp.co.intra_mart.product.eb.jdbc.JdbcManager;
import jp.co.intra_mart.product.eb.jdbc.ModelMapperUtil;
import jp.co.intra_mart.product.eb.jdbc.types.*;
import jp.co.intra_mart.product.eb.message.EBMessageBundle;
import jp.co.intra_mart.product.eb.model.dao.OrderByClause;
import jp.co.intra_mart.product.eb.util.converter.SimpleDataTypeConverter;

/**
 * <!-- begin-user-doc -->
 * 
 * <!-- end-user-doc -->
 * 
 * @generated eBulider
 */
public class EbSCustomerLoginGroupDBDaoImpl extends LoginGroupDBDAO implements
		EbSCustomerDao {

	private JdbcManager jdbcManager = null;

	@Override
	public void setConnectInfo(DataConnector connector, String resource,
			String key, String connect) throws DataConnectException {
		// TODO Auto-generated method stub
		super.setConnectInfo(connector, resource, key, connect);
		this.jdbcManager = new jp.co.intra_mart.product.eb.jdbc.JdbcManager(
				connect, true);
	}

	/**
	 * このMap変数はaddEbSCustomerで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> addEbSCustomerSqlMap = new HashMap<String, String>();
	static {
		addEbSCustomerSqlMap
				.put(
						"0",
						"INSERT INTO EB_S_CUSTOMER (customer_cd,customer_name,insert_user_cd,record_user_cd,insert_date,record_date) VALUES (?,?,?,?,?,?)");
	}

	/**
	 * EB_S_CUSTOMER のレコード追加。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params customerName 得意先名
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @return 登録された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int addEbSCustomer(String customerCd, String customerName,
			String insertUserId, String recordUserId,
			java.util.Date insertDate, java.util.Date recordDate)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.addEbSCustomer"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));

		if (customerName != null) {
			params.add(new StringValueTypeBinder(customerName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		key.append("0");

		String sql = addEbSCustomerSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.addEbSCustomer", sql), e);
		}

	}

	/**
	 * このMap変数はgetEbSCustomerで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSCustomerSqlMap = new HashMap<String, String>();
	static {
		getEbSCustomerSqlMap.put("0",
				"SELECT * FROM eb_s_customer WHERE customer_cd = ?");
	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @return 条件に一致したレコード
	 *         ※複数のレコードが一致した場合、先頭のレコードを返却。またDAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *         BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer getEbSCustomer(
			String customerCd) throws SystemException {

		return getEbSCustomer(customerCd,
				GET_EB_SCUSTOMER_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer getEbSCustomer(
			String customerCd, OrderByClause orderByClause)
			throws SystemException {

		if (orderByClause != null) {
			return getEbSCustomer(customerCd, orderByClause.toSQL());
		} else {
			return getEbSCustomer(customerCd,
					GET_EB_SCUSTOMER_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 *            orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer getEbSCustomer(
			String customerCd, String orderByClause) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.getEbSCustomer"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		if (orderByClause == null) {
			orderByClause = "";
		}
		String sql = getEbSCustomerSqlMap.get(key.toString()) + orderByClause;

		try {
			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> resultList = jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSCustomerMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer>());
			if (resultList.size() > 0) {
				return resultList.get(0);
			} else {
				return null;
			}
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.getEbSCustomer", sql), e);
		}

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSCustomer(String customerCd)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.getEbSCustomer"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		String sql = getEbSCustomerSqlMap.get(key.toString());

		try {
			return (jdbcManager.count(getConnection(), sql, params) > 0);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.getEbSCustomer", sql), e);
		}

	}

	/**
	 * DAO [EB_S_CUSTOMER のレコード取得]のMapperクラスです。
	 */
	private class GetEbSCustomerMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer();

				model.setCustomerCd(ModelMapperUtil.getString(resultSet, 1));
				model.setCustomerName(ModelMapperUtil.getString(resultSet, 2));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 3));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 4));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 5)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 6)));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はgetEbSCustomerListで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSCustomerListSqlMap = new HashMap<String, String>();
	static {
		getEbSCustomerListSqlMap.put("0", "SELECT * FROM EB_S_CUSTOMER");
	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList()
			throws SystemException {

		return getEbSCustomerList(GET_EB_SCUSTOMER_LIST_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			OrderByClause orderByClause) throws SystemException {

		if (orderByClause != null) {
			return getEbSCustomerList(orderByClause.toSQL());
		} else {
			return getEbSCustomerList(GET_EB_SCUSTOMER_LIST_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			String orderByClause) throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSCustomerListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSCustomerListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer>());
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.getEbSCustomerList", sql), e);
		}

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSCustomer>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			int offset, int limit) throws SystemException {

		return getEbSCustomerList(
				GET_EB_SCUSTOMER_LIST_DEFAULT_ORDER_BY_CLAUSE, offset, limit);

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSCustomer>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			OrderByClause orderByClause, int offset, int limit)
			throws SystemException {
		if (orderByClause != null) {
			return getEbSCustomerList(orderByClause.toSQL(), offset, limit);
		} else {
			return getEbSCustomerList(
					GET_EB_SCUSTOMER_LIST_DEFAULT_ORDER_BY_CLAUSE, offset,
					limit);
		}

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSCustomer>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> getEbSCustomerList(
			String orderByClause, int offset, int limit) throws SystemException {

		if (limit == 0) {
			return new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer>();
		} else if (limit < 0) {
			return getEbSCustomerList(orderByClause);
		}

		if (offset < 1) {
			offset = 1;
		}

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSCustomerListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.fetch(
							getConnection(),
							sql,
							params,
							new GetEbSCustomerListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer>(),
							offset, limit);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.getEbSCustomerList", sql), e);
		}

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードの件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public long countGetEbSCustomerList() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = getEbSCustomerListSqlMap.get(key.toString());

		try {
			return jdbcManager.count(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.getEbSCustomerList", sql), e);
		}

	}

	/**
	 * EB_S_CUSTOMER のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSCustomerList() throws SystemException {

		return (countGetEbSCustomerList() > 0);

	}

	/**
	 * DAO [EB_S_CUSTOMER のレコード取得]のMapperクラスです。
	 */
	private class GetEbSCustomerListMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSCustomer();

				model.setCustomerCd(ModelMapperUtil.getString(resultSet, 1));
				model.setCustomerName(ModelMapperUtil.getString(resultSet, 2));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 3));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 4));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 5)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 6)));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はremoveEbSCustomerで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSCustomerSqlMap = new HashMap<String, String>();
	static {
		removeEbSCustomerSqlMap.put("0",
				"DELETE FROM eb_s_customer WHERE customer_cd = ?");
	}

	/**
	 * EB_S_CUSTOMER のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSCustomer(String customerCd) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.removeEbSCustomer"));
		}
		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		String sql = removeEbSCustomerSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.removeEbSCustomer", sql), e);
		}

	}

	/**
	 * このMap変数はremoveEbSCustomersで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSCustomersSqlMap = new HashMap<String, String>();
	static {
		removeEbSCustomersSqlMap.put("0", "DELETE FROM EB_S_CUSTOMER");
	}

	/**
	 * EB_S_CUSTOMER のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSCustomers() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = removeEbSCustomersSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.removeEbSCustomers", sql), e);
		}

	}

	/**
	 * このMap変数はupdateEbSCustomerで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> updateEbSCustomerSqlMap = new HashMap<String, String>();
	static {
		updateEbSCustomerSqlMap
				.put(
						"0",
						"UPDATE eb_s_customer SET customer_name = ?, insert_user_cd = ?, record_user_cd = ?, insert_date = ?, record_date = ? WHERE customer_cd = ?");
	}

	/**
	 * EB_S_CUSTOMER のレコード更新。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_CUSTOMER に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * 
	 * @params customerName 得意先名
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params customerCd 得意先コード
	 * @return 更新された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int updateEbSCustomer(String customerName, String insertUserId,
			String recordUserId, java.util.Date insertDate,
			java.util.Date recordDate, String customerCd)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.updateEbSCustomer"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		if (customerName != null) {
			params.add(new StringValueTypeBinder(customerName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		String sql = updateEbSCustomerSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_customer.updateEbSCustomer", sql), e);
		}

	}
}
