
/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package jp.co.intra_mart.product.eb.sample.simplesales.data.dm;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import jp.co.intra_mart.framework.base.data.DataConnectException;
import jp.co.intra_mart.framework.base.data.DataConnector;
import jp.co.intra_mart.framework.base.data.LoginGroupDBDAO;
import jp.co.intra_mart.framework.system.exception.SystemException;
import jp.co.intra_mart.product.eb.jdbc.JdbcManager;
import jp.co.intra_mart.product.eb.jdbc.ModelMapperUtil;
import jp.co.intra_mart.product.eb.jdbc.types.*;
import jp.co.intra_mart.product.eb.message.EBMessageBundle;
import jp.co.intra_mart.product.eb.model.dao.OrderByClause;
import jp.co.intra_mart.product.eb.util.converter.SimpleDataTypeConverter;

/**
 * <!-- begin-user-doc -->
 * 
 * <!-- end-user-doc -->
 * 
 * @generated eBulider
 */
public class EbSProductLoginGroupDBDaoImpl extends LoginGroupDBDAO implements
		EbSProductDao {

	private JdbcManager jdbcManager = null;

	@Override
	public void setConnectInfo(DataConnector connector, String resource,
			String key, String connect) throws DataConnectException {
		// TODO Auto-generated method stub
		super.setConnectInfo(connector, resource, key, connect);
		this.jdbcManager = new jp.co.intra_mart.product.eb.jdbc.JdbcManager(
				connect, true);
	}

	/**
	 * このMap変数はaddEbSProductで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> addEbSProductSqlMap = new HashMap<String, String>();
	static {
		addEbSProductSqlMap
				.put(
						"0",
						"INSERT INTO EB_S_PRODUCT (product_cd,product_name,insert_user_cd,record_user_cd,insert_date,record_date) VALUES (?,?,?,?,?,?)");
	}

	/**
	 * EB_S_PRODUCT のレコード追加。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * 
	 * @params productCd 商品コード
	 * @params productName 商品名
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @return 登録された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int addEbSProduct(String productCd, String productName,
			String insertUserId, String recordUserId,
			java.util.Date insertDate, java.util.Date recordDate)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.addEbSProduct"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(productCd));

		if (productName != null) {
			params.add(new StringValueTypeBinder(productName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		key.append("0");

		String sql = addEbSProductSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.addEbSProduct", sql), e);
		}

	}

	/**
	 * このMap変数はgetEbSProductで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSProductSqlMap = new HashMap<String, String>();
	static {
		getEbSProductSqlMap.put("0",
				"SELECT * FROM eb_s_product WHERE product_cd = ?");
	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params productCd 商品コード
	 * @return 条件に一致したレコード
	 *         ※複数のレコードが一致した場合、先頭のレコードを返却。またDAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *         BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct getEbSProduct(
			String productCd) throws SystemException {

		return getEbSProduct(productCd, GET_EB_SPRODUCT_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params productCd 商品コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct getEbSProduct(
			String productCd, OrderByClause orderByClause)
			throws SystemException {

		if (orderByClause != null) {
			return getEbSProduct(productCd, orderByClause.toSQL());
		} else {
			return getEbSProduct(productCd,
					GET_EB_SPRODUCT_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params productCd 商品コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 *            orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct getEbSProduct(
			String productCd, String orderByClause) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.getEbSProduct"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		if (orderByClause == null) {
			orderByClause = "";
		}
		String sql = getEbSProductSqlMap.get(key.toString()) + orderByClause;

		try {
			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> resultList = jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSProductMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct>());
			if (resultList.size() > 0) {
				return resultList.get(0);
			} else {
				return null;
			}
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.getEbSProduct", sql), e);
		}

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params productCd 商品コード
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSProduct(String productCd) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.getEbSProduct"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		String sql = getEbSProductSqlMap.get(key.toString());

		try {
			return (jdbcManager.count(getConnection(), sql, params) > 0);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.getEbSProduct", sql), e);
		}

	}

	/**
	 * DAO [EB_S_PRODUCT のレコード取得]のMapperクラスです。
	 */
	private class GetEbSProductMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct();

				model.setProductCd(ModelMapperUtil.getString(resultSet, 1));
				model.setProductName(ModelMapperUtil.getString(resultSet, 2));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 3));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 4));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 5)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 6)));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はgetEbSProductListで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSProductListSqlMap = new HashMap<String, String>();
	static {
		getEbSProductListSqlMap.put("0", "SELECT * FROM EB_S_PRODUCT");
	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> getEbSProductList()
			throws SystemException {

		return getEbSProductList(GET_EB_SPRODUCT_LIST_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> getEbSProductList(
			OrderByClause orderByClause) throws SystemException {

		if (orderByClause != null) {
			return getEbSProductList(orderByClause.toSQL());
		} else {
			return getEbSProductList(GET_EB_SPRODUCT_LIST_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> getEbSProductList(
			String orderByClause) throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSProductListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSProductListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct>());
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.getEbSProductList", sql), e);
		}

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProduct>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> getEbSProductList(
			int offset, int limit) throws SystemException {

		return getEbSProductList(GET_EB_SPRODUCT_LIST_DEFAULT_ORDER_BY_CLAUSE,
				offset, limit);

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProduct>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> getEbSProductList(
			OrderByClause orderByClause, int offset, int limit)
			throws SystemException {
		if (orderByClause != null) {
			return getEbSProductList(orderByClause.toSQL(), offset, limit);
		} else {
			return getEbSProductList(
					GET_EB_SPRODUCT_LIST_DEFAULT_ORDER_BY_CLAUSE, offset, limit);
		}

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProduct>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> getEbSProductList(
			String orderByClause, int offset, int limit) throws SystemException {

		if (limit == 0) {
			return new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct>();
		} else if (limit < 0) {
			return getEbSProductList(orderByClause);
		}

		if (offset < 1) {
			offset = 1;
		}

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSProductListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.fetch(
							getConnection(),
							sql,
							params,
							new GetEbSProductListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct>(),
							offset, limit);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.getEbSProductList", sql), e);
		}

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードの件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public long countGetEbSProductList() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = getEbSProductListSqlMap.get(key.toString());

		try {
			return jdbcManager.count(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.getEbSProductList", sql), e);
		}

	}

	/**
	 * EB_S_PRODUCT のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSProductList() throws SystemException {

		return (countGetEbSProductList() > 0);

	}

	/**
	 * DAO [EB_S_PRODUCT のレコード取得]のMapperクラスです。
	 */
	private class GetEbSProductListMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProduct();

				model.setProductCd(ModelMapperUtil.getString(resultSet, 1));
				model.setProductName(ModelMapperUtil.getString(resultSet, 2));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 3));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 4));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 5)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 6)));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はremoveEbSProductで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSProductSqlMap = new HashMap<String, String>();
	static {
		removeEbSProductSqlMap.put("0",
				"DELETE FROM eb_s_product WHERE product_cd = ?");
	}

	/**
	 * EB_S_PRODUCT のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @params productCd 商品コード
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSProduct(String productCd) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.removeEbSProduct"));
		}
		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		String sql = removeEbSProductSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.removeEbSProduct", sql), e);
		}

	}

	/**
	 * このMap変数はremoveEbSProductsで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSProductsSqlMap = new HashMap<String, String>();
	static {
		removeEbSProductsSqlMap.put("0", "DELETE FROM EB_S_PRODUCT");
	}

	/**
	 * EB_S_PRODUCT のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSProducts() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = removeEbSProductsSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.removeEbSProducts", sql), e);
		}

	}

	/**
	 * このMap変数はupdateEbSProductで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> updateEbSProductSqlMap = new HashMap<String, String>();
	static {
		updateEbSProductSqlMap
				.put(
						"0",
						"UPDATE eb_s_product SET product_name = ?, insert_user_cd = ?, record_user_cd = ?, insert_date = ?, record_date = ? WHERE product_cd = ?");
	}

	/**
	 * EB_S_PRODUCT のレコード更新。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * 
	 * @params productName 商品名
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params productCd 商品コード
	 * @return 更新された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int updateEbSProduct(String productName, String insertUserId,
			String recordUserId, java.util.Date insertDate,
			java.util.Date recordDate, String productCd) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.updateEbSProduct"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		if (productName != null) {
			params.add(new StringValueTypeBinder(productName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		String sql = updateEbSProductSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product.updateEbSProduct", sql), e);
		}

	}
}
