
/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package jp.co.intra_mart.product.eb.sample.simplesales.data.dm;

import java.util.List;
import jp.co.intra_mart.framework.base.data.DataConnector;
import jp.co.intra_mart.framework.system.exception.SystemException;
import jp.co.intra_mart.product.eb.model.dao.OrderByClause;

/**
 * <!-- begin-user-doc -->
 * 
 * このクラスを取得するためのgetDAOメソッド ログイングループデータソース用
 * (jp.co.intra_mart.product.eb.sample.simplesales
 * .data.dm.EbSProductUnitPriceDao)
 * getDAO("jp.co.intra_mart.product.eb.sample.simplesales.conf.simplesales" ,
 * "dm.eb_s_product_unit_price" , loginGroupId )
 * 
 * システムデータソース用 (jp.co.intra_mart.product.eb.sample.simplesales.data.dm.
 * EbSProductUnitPriceDao) getDAO(
 * "jp.co.intra_mart.product.eb.sample.simplesales.conf.simplesales_sys" ,
 * "dm.eb_s_product_unit_price" , connectId )
 * 
 * <!-- end-user-doc -->
 * 
 * @generated intra-mart e Bulider
 */
public interface EbSProductUnitPriceDao {

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード追加。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @params productUnitPrice 商品単価
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params productName 商品名
	 * @params customerName 得意先名
	 * @return 登録された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int addEbSProductUnitPrice(String customerCd, String productCd,
			java.math.BigDecimal productUnitPrice, String insertUserId,
			String recordUserId, java.util.Date insertDate,
			java.util.Date recordDate, String productName, String customerName)
			throws SystemException;

	public static final String GET_EB_SPRODUCT_UNIT_PRICE_DEFAULT_ORDER_BY_CLAUSE = "";

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 条件に一致したレコード
	 *         ※複数のレコードが一致した場合、先頭のレコードを返却。またDAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *         BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice getEbSProductUnitPrice(
			String customerCd, String productCd) throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice getEbSProductUnitPrice(
			String customerCd, String productCd, OrderByClause orderByClause)
			throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice getEbSProductUnitPrice(
			String customerCd, String productCd, String orderByClause)
			throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSProductUnitPrice(String customerCd,
			String productCd) throws SystemException;

	public static final String GET_EB_SPRODUCT_UNIT_PRICE_LIST_DEFAULT_ORDER_BY_CLAUSE = "";

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList()
			throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			OrderByClause orderByClause) throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			String orderByClause) throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProductUnitPrice
	 *            >)が返却されます。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			int offset, int limit) throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProductUnitPrice
	 *            >)が返却されます。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			OrderByClause orderByClause, int offset, int limit)
			throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProductUnitPrice
	 *            >)が返却されます。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			String orderByClause, int offset, int limit) throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードの件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public long countGetEbSProductUnitPriceList() throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSProductUnitPriceList() throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSProductUnitPrice(String customerCd, String productCd)
			throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSProductUnitPrices() throws SystemException;

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード更新。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * 
	 * @params productUnitPrice 商品単価
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params productName 商品名
	 * @params customerName 得意先名
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 更新された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int updateEbSProductUnitPrice(java.math.BigDecimal productUnitPrice,
			String insertUserId, String recordUserId,
			java.util.Date insertDate, java.util.Date recordDate,
			String productName, String customerName, String customerCd,
			String productCd) throws SystemException;
}
