
/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package jp.co.intra_mart.product.eb.sample.simplesales.data.dm;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import jp.co.intra_mart.framework.base.data.DataConnectException;
import jp.co.intra_mart.framework.base.data.DataConnector;
import jp.co.intra_mart.framework.base.data.LoginGroupDBDAO;
import jp.co.intra_mart.framework.system.exception.SystemException;
import jp.co.intra_mart.product.eb.jdbc.JdbcManager;
import jp.co.intra_mart.product.eb.jdbc.ModelMapperUtil;
import jp.co.intra_mart.product.eb.jdbc.types.*;
import jp.co.intra_mart.product.eb.message.EBMessageBundle;
import jp.co.intra_mart.product.eb.model.dao.OrderByClause;
import jp.co.intra_mart.product.eb.util.converter.SimpleDataTypeConverter;

/**
 * <!-- begin-user-doc -->
 * 
 * <!-- end-user-doc -->
 * 
 * @generated eBulider
 */
public class EbSProductUnitPriceLoginGroupDBDaoImpl extends LoginGroupDBDAO
		implements EbSProductUnitPriceDao {

	private JdbcManager jdbcManager = null;

	@Override
	public void setConnectInfo(DataConnector connector, String resource,
			String key, String connect) throws DataConnectException {
		// TODO Auto-generated method stub
		super.setConnectInfo(connector, resource, key, connect);
		this.jdbcManager = new jp.co.intra_mart.product.eb.jdbc.JdbcManager(
				connect, true);
	}

	/**
	 * このMap変数はaddEbSProductUnitPriceで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> addEbSProductUnitPriceSqlMap = new HashMap<String, String>();
	static {
		addEbSProductUnitPriceSqlMap
				.put(
						"0",
						"INSERT INTO EB_S_PRODUCT_UNIT_PRICE (customer_cd,product_cd,product_unit_price,insert_user_cd,record_user_cd,insert_date,record_date,product_name,customer_name) VALUES (?,?,?,?,?,?,?,?,?)");
	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード追加。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @params productUnitPrice 商品単価
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params productName 商品名
	 * @params customerName 得意先名
	 * @return 登録された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int addEbSProductUnitPrice(String customerCd, String productCd,
			java.math.BigDecimal productUnitPrice, String insertUserId,
			String recordUserId, java.util.Date insertDate,
			java.util.Date recordDate, String productName, String customerName)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.addEbSProductUnitPrice"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));

		params.add(new StringValueTypeBinder(productCd));

		if (productUnitPrice != null) {
			params.add(new BigDecimalValueTypeBinder(productUnitPrice));
		} else {
			params.add(new BigDecimalValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (productName != null) {
			params.add(new StringValueTypeBinder(productName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (customerName != null) {
			params.add(new StringValueTypeBinder(customerName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		key.append("0");

		String sql = addEbSProductUnitPriceSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.addEbSProductUnitPrice", sql),
					e);
		}

	}

	/**
	 * このMap変数はgetEbSProductUnitPriceで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSProductUnitPriceSqlMap = new HashMap<String, String>();
	static {
		getEbSProductUnitPriceSqlMap
				.put(
						"00",
						"SELECT * FROM eb_s_product_unit_price WHERE customer_cd = ? AND product_cd = ?");
	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 条件に一致したレコード
	 *         ※複数のレコードが一致した場合、先頭のレコードを返却。またDAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *         BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice getEbSProductUnitPrice(
			String customerCd, String productCd) throws SystemException {

		return getEbSProductUnitPrice(customerCd, productCd,
				GET_EB_SPRODUCT_UNIT_PRICE_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice getEbSProductUnitPrice(
			String customerCd, String productCd, OrderByClause orderByClause)
			throws SystemException {

		if (orderByClause != null) {
			return getEbSProductUnitPrice(customerCd, productCd, orderByClause
					.toSQL());
		} else {
			return getEbSProductUnitPrice(customerCd, productCd,
					GET_EB_SPRODUCT_UNIT_PRICE_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 *            orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice getEbSProductUnitPrice(
			String customerCd, String productCd, String orderByClause)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.getEbSProductUnitPrice"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		if (orderByClause == null) {
			orderByClause = "";
		}
		String sql = getEbSProductUnitPriceSqlMap.get(key.toString())
				+ orderByClause;

		try {
			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> resultList = jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSProductUnitPriceMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice>());
			if (resultList.size() > 0) {
				return resultList.get(0);
			} else {
				return null;
			}
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.getEbSProductUnitPrice", sql),
					e);
		}

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSProductUnitPrice(String customerCd,
			String productCd) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.getEbSProductUnitPrice"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		String sql = getEbSProductUnitPriceSqlMap.get(key.toString());

		try {
			return (jdbcManager.count(getConnection(), sql, params) > 0);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.getEbSProductUnitPrice", sql),
					e);
		}

	}

	/**
	 * DAO [EB_S_PRODUCT_UNIT_PRICE のレコード取得]のMapperクラスです。
	 */
	private class GetEbSProductUnitPriceMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice();

				model.setCustomerCd(ModelMapperUtil.getString(resultSet, 1));
				model.setProductCd(ModelMapperUtil.getString(resultSet, 2));
				model.setProductUnitPrice(ModelMapperUtil.getBigDecimal(
						resultSet, 3));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 4));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 5));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 6)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 7)));
				model.setProductName(ModelMapperUtil.getString(resultSet, 8));
				model.setCustomerName(ModelMapperUtil.getString(resultSet, 9));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はgetEbSProductUnitPriceListで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSProductUnitPriceListSqlMap = new HashMap<String, String>();
	static {
		getEbSProductUnitPriceListSqlMap.put("0",
				"SELECT * FROM EB_S_PRODUCT_UNIT_PRICE");
	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList()
			throws SystemException {

		return getEbSProductUnitPriceList(GET_EB_SPRODUCT_UNIT_PRICE_LIST_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			OrderByClause orderByClause) throws SystemException {

		if (orderByClause != null) {
			return getEbSProductUnitPriceList(orderByClause.toSQL());
		} else {
			return getEbSProductUnitPriceList(GET_EB_SPRODUCT_UNIT_PRICE_LIST_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			String orderByClause) throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSProductUnitPriceListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSProductUnitPriceListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice>());
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.getEbSProductUnitPriceList",
					sql), e);
		}

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProductUnitPrice
	 *            >)が返却されます。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			int offset, int limit) throws SystemException {

		return getEbSProductUnitPriceList(
				GET_EB_SPRODUCT_UNIT_PRICE_LIST_DEFAULT_ORDER_BY_CLAUSE,
				offset, limit);

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProductUnitPrice
	 *            >)が返却されます。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			OrderByClause orderByClause, int offset, int limit)
			throws SystemException {
		if (orderByClause != null) {
			return getEbSProductUnitPriceList(orderByClause.toSQL(), offset,
					limit);
		} else {
			return getEbSProductUnitPriceList(
					GET_EB_SPRODUCT_UNIT_PRICE_LIST_DEFAULT_ORDER_BY_CLAUSE,
					offset, limit);
		}

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSProductUnitPrice
	 *            >)が返却されます。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> getEbSProductUnitPriceList(
			String orderByClause, int offset, int limit) throws SystemException {

		if (limit == 0) {
			return new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice>();
		} else if (limit < 0) {
			return getEbSProductUnitPriceList(orderByClause);
		}

		if (offset < 1) {
			offset = 1;
		}

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSProductUnitPriceListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.fetch(
							getConnection(),
							sql,
							params,
							new GetEbSProductUnitPriceListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice>(),
							offset, limit);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.getEbSProductUnitPriceList",
					sql), e);
		}

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードの件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public long countGetEbSProductUnitPriceList() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = getEbSProductUnitPriceListSqlMap.get(key.toString());

		try {
			return jdbcManager.count(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.getEbSProductUnitPriceList",
					sql), e);
		}

	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSProductUnitPriceList() throws SystemException {

		return (countGetEbSProductUnitPriceList() > 0);

	}

	/**
	 * DAO [EB_S_PRODUCT_UNIT_PRICE のレコード取得]のMapperクラスです。
	 */
	private class GetEbSProductUnitPriceListMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSProductUnitPrice();

				model.setCustomerCd(ModelMapperUtil.getString(resultSet, 1));
				model.setProductCd(ModelMapperUtil.getString(resultSet, 2));
				model.setProductUnitPrice(ModelMapperUtil.getBigDecimal(
						resultSet, 3));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 4));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 5));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 6)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 7)));
				model.setProductName(ModelMapperUtil.getString(resultSet, 8));
				model.setCustomerName(ModelMapperUtil.getString(resultSet, 9));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はremoveEbSProductUnitPriceで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSProductUnitPriceSqlMap = new HashMap<String, String>();
	static {
		removeEbSProductUnitPriceSqlMap
				.put("00",
						"DELETE FROM eb_s_product_unit_price WHERE customer_cd = ? AND product_cd = ?");
	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSProductUnitPrice(String customerCd, String productCd)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.removeEbSProductUnitPrice"));
		}
		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		String sql = removeEbSProductUnitPriceSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(
					EBMessageBundle
							.getMessage(
									"dao.SystemException",
									"jp.co.intra_mart.product.eb.sample.simplesales",
									"dm.eb_s_product_unit_price.removeEbSProductUnitPrice",
									sql), e);
		}

	}

	/**
	 * このMap変数はremoveEbSProductUnitPricesで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSProductUnitPricesSqlMap = new HashMap<String, String>();
	static {
		removeEbSProductUnitPricesSqlMap.put("0",
				"DELETE FROM EB_S_PRODUCT_UNIT_PRICE");
	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSProductUnitPrices() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = removeEbSProductUnitPricesSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.removeEbSProductUnitPrices",
					sql), e);
		}

	}

	/**
	 * このMap変数はupdateEbSProductUnitPriceで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> updateEbSProductUnitPriceSqlMap = new HashMap<String, String>();
	static {
		updateEbSProductUnitPriceSqlMap
				.put(
						"00",
						"UPDATE eb_s_product_unit_price SET product_unit_price = ?, insert_user_cd = ?, record_user_cd = ?, insert_date = ?, record_date = ?, product_name = ?, customer_name = ? WHERE customer_cd = ? AND product_cd = ?");
	}

	/**
	 * EB_S_PRODUCT_UNIT_PRICE のレコード更新。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_PRODUCT_UNIT_PRICE に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * 
	 * @params productUnitPrice 商品単価
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params productName 商品名
	 * @params customerName 得意先名
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @return 更新された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int updateEbSProductUnitPrice(java.math.BigDecimal productUnitPrice,
			String insertUserId, String recordUserId,
			java.util.Date insertDate, java.util.Date recordDate,
			String productName, String customerName, String customerCd,
			String productCd) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_product_unit_price.updateEbSProductUnitPrice"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		if (productUnitPrice != null) {
			params.add(new BigDecimalValueTypeBinder(productUnitPrice));
		} else {
			params.add(new BigDecimalValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (productName != null) {
			params.add(new StringValueTypeBinder(productName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (customerName != null) {
			params.add(new StringValueTypeBinder(customerName));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		params.add(new StringValueTypeBinder(customerCd));
		key.append("0");

		params.add(new StringValueTypeBinder(productCd));
		key.append("0");

		String sql = updateEbSProductUnitPriceSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(
					EBMessageBundle
							.getMessage(
									"dao.SystemException",
									"jp.co.intra_mart.product.eb.sample.simplesales",
									"dm.eb_s_product_unit_price.updateEbSProductUnitPrice",
									sql), e);
		}

	}
}
