
/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package jp.co.intra_mart.product.eb.sample.simplesales.data.dm;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import jp.co.intra_mart.framework.base.data.DataConnectException;
import jp.co.intra_mart.framework.base.data.DataConnector;
import jp.co.intra_mart.framework.base.data.LoginGroupDBDAO;
import jp.co.intra_mart.framework.system.exception.SystemException;
import jp.co.intra_mart.product.eb.jdbc.JdbcManager;
import jp.co.intra_mart.product.eb.jdbc.ModelMapperUtil;
import jp.co.intra_mart.product.eb.jdbc.types.*;
import jp.co.intra_mart.product.eb.message.EBMessageBundle;
import jp.co.intra_mart.product.eb.model.dao.OrderByClause;
import jp.co.intra_mart.product.eb.util.converter.SimpleDataTypeConverter;

/**
 * <!-- begin-user-doc -->
 * 
 * <!-- end-user-doc -->
 * 
 * @generated eBulider
 */
public class EbSSalesSlipLoginGroupDBDaoImpl extends LoginGroupDBDAO implements
		EbSSalesSlipDao {

	private JdbcManager jdbcManager = null;

	@Override
	public void setConnectInfo(DataConnector connector, String resource,
			String key, String connect) throws DataConnectException {
		// TODO Auto-generated method stub
		super.setConnectInfo(connector, resource, key, connect);
		this.jdbcManager = new jp.co.intra_mart.product.eb.jdbc.JdbcManager(
				connect, true);
	}

	/**
	 * このMap変数はaddEbSSalesSlipで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> addEbSSalesSlipSqlMap = new HashMap<String, String>();
	static {
		addEbSSalesSlipSqlMap
				.put(
						"0",
						"INSERT INTO EB_S_SALES_SLIP (sales_slip_cd,sales_date,customer_cd,product_cd,product_sales_amount,insert_user_cd,record_user_cd,insert_date,record_date) VALUES (?,?,?,?,?,?,?,?,?)");
	}

	/**
	 * EB_S_SALES_SLIP のレコード追加。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件追加します。</dd>
	 * </dl>
	 * 
	 * @params salesSlipCd 伝票コード
	 * @params salesDate 売上日
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @params productSalesAmount 商品売上数
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @return 登録された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int addEbSSalesSlip(String salesSlipCd, String salesDate,
			String customerCd, String productCd, String productSalesAmount,
			String insertUserId, String recordUserId,
			java.util.Date insertDate, java.util.Date recordDate)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (salesSlipCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("salesSlipCd");
			separator = ", ";
		}
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.addEbSSalesSlip"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(salesSlipCd));

		if (salesDate != null) {
			params.add(new StringValueTypeBinder(salesDate));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		params.add(new StringValueTypeBinder(customerCd));

		params.add(new StringValueTypeBinder(productCd));

		if (productSalesAmount != null) {
			params.add(new StringValueTypeBinder(productSalesAmount));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		key.append("0");

		String sql = addEbSSalesSlipSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.addEbSSalesSlip", sql), e);
		}

	}

	/**
	 * このMap変数はgetEbSSalesSlipで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSSalesSlipSqlMap = new HashMap<String, String>();
	static {
		getEbSSalesSlipSqlMap.put("0",
				"SELECT * FROM eb_s_sales_slip WHERE sales_slip_cd = ?");
	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params salesSlipCd 伝票コード
	 * @return 条件に一致したレコード
	 *         ※複数のレコードが一致した場合、先頭のレコードを返却。またDAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *         BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip getEbSSalesSlip(
			String salesSlipCd) throws SystemException {

		return getEbSSalesSlip(salesSlipCd,
				GET_EB_S_SALES_SLIP_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params salesSlipCd 伝票コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip getEbSSalesSlip(
			String salesSlipCd, OrderByClause orderByClause)
			throws SystemException {

		if (orderByClause != null) {
			return getEbSSalesSlip(salesSlipCd, orderByClause.toSQL());
		} else {
			return getEbSSalesSlip(salesSlipCd,
					GET_EB_S_SALES_SLIP_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params salesSlipCd 伝票コード
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※nullが指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)が利用されます。
	 *            orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード ※複数のレコードが一致した場合、先頭のレコードを返却
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip getEbSSalesSlip(
			String salesSlipCd, String orderByClause) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (salesSlipCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("salesSlipCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.getEbSSalesSlip"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(salesSlipCd));
		key.append("0");

		if (orderByClause == null) {
			orderByClause = "";
		}
		String sql = getEbSSalesSlipSqlMap.get(key.toString()) + orderByClause;

		try {
			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> resultList = jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSSalesSlipMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip>());
			if (resultList.size() > 0) {
				return resultList.get(0);
			} else {
				return null;
			}
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.getEbSSalesSlip", sql), e);
		}

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件取得します。</dd>
	 * </dl>
	 * 
	 * @params salesSlipCd 伝票コード
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSSalesSlip(String salesSlipCd)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (salesSlipCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("salesSlipCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.getEbSSalesSlip"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(salesSlipCd));
		key.append("0");

		String sql = getEbSSalesSlipSqlMap.get(key.toString());

		try {
			return (jdbcManager.count(getConnection(), sql, params) > 0);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.getEbSSalesSlip", sql), e);
		}

	}

	/**
	 * DAO [EB_S_SALES_SLIP のレコード取得]のMapperクラスです。
	 */
	private class GetEbSSalesSlipMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip();

				model.setSalesSlipCd(ModelMapperUtil.getString(resultSet, 1));
				model.setSalesDate(ModelMapperUtil.getString(resultSet, 2));
				model.setCustomerCd(ModelMapperUtil.getString(resultSet, 3));
				model.setProductCd(ModelMapperUtil.getString(resultSet, 4));
				model.setProductSalesAmount(ModelMapperUtil.getString(
						resultSet, 5));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 6));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 7));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 8)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 9)));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はgetEbSSalesSlipListで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> getEbSSalesSlipListSqlMap = new HashMap<String, String>();
	static {
		getEbSSalesSlipListSqlMap.put("0", "SELECT * FROM EB_S_SALES_SLIP");
	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> getEbSSalesSlipList()
			throws SystemException {

		return getEbSSalesSlipList(GET_EB_S_SALES_SLIP_LIST_DEFAULT_ORDER_BY_CLAUSE);

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> getEbSSalesSlipList(
			OrderByClause orderByClause) throws SystemException {

		if (orderByClause != null) {
			return getEbSSalesSlipList(orderByClause.toSQL());
		} else {
			return getEbSSalesSlipList(GET_EB_S_SALES_SLIP_LIST_DEFAULT_ORDER_BY_CLAUSE);
		}

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> getEbSSalesSlipList(
			String orderByClause) throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSSalesSlipListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.select(
							getConnection(),
							sql,
							params,
							new GetEbSSalesSlipListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip>());
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.getEbSSalesSlipList", sql), e);
		}

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSSalesSlip>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード ※DAOコンポーネントで定義されたデフォルトのソート条件(ORDER BY句)でソートされます。
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> getEbSSalesSlipList(
			int offset, int limit) throws SystemException {

		return getEbSSalesSlipList(
				GET_EB_S_SALES_SLIP_LIST_DEFAULT_ORDER_BY_CLAUSE, offset, limit);

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSSalesSlip>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> getEbSSalesSlipList(
			OrderByClause orderByClause, int offset, int limit)
			throws SystemException {
		if (orderByClause != null) {
			return getEbSSalesSlipList(orderByClause.toSQL(), offset, limit);
		} else {
			return getEbSSalesSlipList(
					GET_EB_S_SALES_SLIP_LIST_DEFAULT_ORDER_BY_CLAUSE, offset,
					limit);
		}

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @param orderByClause
	 *            ソート条件(ORDER BY句)
	 *            ※null、もしくは空文字が指定された場合、DAOコンポーネントで定義されたデフォルトのソート条件(ORDER
	 *            BY句)が利用されます。 orderBy句を直接Stringで入力する場合は始点に半角スペースを入れてください
	 * @param offset
	 *            取得する開始位置 ※1以上の値を指定してください。1より小さい値の場合、開始位置は1になります。
	 * @param limit
	 *            開始位置から取得するレコード数
	 *            ※1以上の値を指定してください。0の場合、SQLは実行されず、空のリスト(List<jp.co
	 *            .intra_mart.product
	 *            .eb.sample.simplesales.dm.EbSSalesSlip>)が返却されます
	 *            。0より小さい値が指定された場合、全件取得されます。
	 * @return 条件に一致したレコード
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> getEbSSalesSlipList(
			String orderByClause, int offset, int limit) throws SystemException {

		if (limit == 0) {
			return new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip>();
		} else if (limit < 0) {
			return getEbSSalesSlipList(orderByClause);
		}

		if (offset < 1) {
			offset = 1;
		}

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		if (orderByClause == null) {
			orderByClause = "";
		}

		String sql = getEbSSalesSlipListSqlMap.get(key.toString())
				+ orderByClause;

		try {
			return jdbcManager
					.fetch(
							getConnection(),
							sql,
							params,
							new GetEbSSalesSlipListMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip>(),
							offset, limit);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.getEbSSalesSlipList", sql), e);
		}

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードの件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public long countGetEbSSalesSlipList() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = getEbSSalesSlipListSqlMap.get(key.toString());

		try {
			return jdbcManager.count(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.getEbSSalesSlipList", sql), e);
		}

	}

	/**
	 * EB_S_SALES_SLIP のレコード取得。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを全件取得します。</dd>
	 * </dl>
	 * 
	 * @return 条件に一致したレコードが存在する場合 true、存在しない場合 false
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public boolean existsGetEbSSalesSlipList() throws SystemException {

		return (countGetEbSSalesSlipList() > 0);

	}

	/**
	 * DAO [EB_S_SALES_SLIP のレコード取得]のMapperクラスです。
	 */
	private class GetEbSSalesSlipListMapper<M>
			implements
			jp.co.intra_mart.product.eb.jdbc.IModelMapper<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> {

		public List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> createModel(
				ResultSet resultSet) throws SQLException {

			List<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip> resultList = new ArrayList<jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip>();
			while (resultSet.next()) {

				jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip model = new jp.co.intra_mart.product.eb.sample.simplesales.dm.EbSSalesSlip();

				model.setSalesSlipCd(ModelMapperUtil.getString(resultSet, 1));
				model.setSalesDate(ModelMapperUtil.getString(resultSet, 2));
				model.setCustomerCd(ModelMapperUtil.getString(resultSet, 3));
				model.setProductCd(ModelMapperUtil.getString(resultSet, 4));
				model.setProductSalesAmount(ModelMapperUtil.getString(
						resultSet, 5));
				model.setInsertUserId(ModelMapperUtil.getString(resultSet, 6));
				model.setRecordUserId(ModelMapperUtil.getString(resultSet, 7));
				model.setInsertDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 8)));
				model.setRecordDate(SimpleDataTypeConverter
						.convertStringToDate(ModelMapperUtil.getString(
								resultSet, 9)));

				resultList.add(model);
			}
			return resultList;
		}
	}

	/**
	 * このMap変数はremoveEbSSalesSlipで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSSalesSlipSqlMap = new HashMap<String, String>();
	static {
		removeEbSSalesSlipSqlMap.put("0",
				"DELETE FROM eb_s_sales_slip WHERE sales_slip_cd = ?");
	}

	/**
	 * EB_S_SALES_SLIP のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @params salesSlipCd 伝票コード
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSSalesSlip(String salesSlipCd) throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (salesSlipCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("salesSlipCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.removeEbSSalesSlip"));
		}
		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		params.add(new StringValueTypeBinder(salesSlipCd));
		key.append("0");

		String sql = removeEbSSalesSlipSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.removeEbSSalesSlip", sql), e);
		}

	}

	/**
	 * このMap変数はremoveEbSSalesSlipsで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> removeEbSSalesSlipsSqlMap = new HashMap<String, String>();
	static {
		removeEbSSalesSlipsSqlMap.put("0", "DELETE FROM EB_S_SALES_SLIP");
	}

	/**
	 * EB_S_SALES_SLIP のレコード削除。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件削除します。</dd>
	 * </dl>
	 * 
	 * @return 削除された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int removeEbSSalesSlips() throws SystemException {

		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();
		StringBuilder key = new StringBuilder("0");
		String sql = removeEbSSalesSlipsSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.removeEbSSalesSlips", sql), e);
		}

	}

	/**
	 * このMap変数はupdateEbSSalesSlipで利用される可能性のあるSQL一覧の情報を保持します。
	 * keyはメソッド内でPreparedStatementでsetされる引数がnullかどうかをチェックし、その結果によって構成される文字列です。<br/>
	 * keyにマップされるSQLは、生成されたkeyの結果から実行すべきSQL文を保持しています。
	 */
	private static Map<String, String> updateEbSSalesSlipSqlMap = new HashMap<String, String>();
	static {
		updateEbSSalesSlipSqlMap
				.put(
						"0",
						"UPDATE eb_s_sales_slip SET sales_date = ?, customer_cd = ?, product_cd = ?, product_sales_amount = ?, insert_user_cd = ?, record_user_cd = ?, insert_date = ?, record_date = ? WHERE sales_slip_cd = ?");
	}

	/**
	 * EB_S_SALES_SLIP のレコード更新。<br/>
	 * <br/>
	 * <dl>
	 * <dt>概要</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * <dl>
	 * <dt>補足</dt>
	 * <dd>テーブル EB_S_SALES_SLIP に対して、レコードを１件更新します。</dd>
	 * </dl>
	 * 
	 * @params salesDate 売上日
	 * @params customerCd 得意先コード
	 * @params productCd 商品コード
	 * @params productSalesAmount 商品売上数
	 * @params insertUserId 登録ユーザID
	 * @params recordUserId 更新ユーザID
	 * @params insertDate 登録日
	 * @params recordDate 更新日
	 * @params salesSlipCd 伝票コード
	 * @return 更新された件数
	 * @throws SystemException
	 *             SQL実行中にSQLExceptionが発生した場合にthrowされます
	 */
	public int updateEbSSalesSlip(String salesDate, String customerCd,
			String productCd, String productSalesAmount, String insertUserId,
			String recordUserId, java.util.Date insertDate,
			java.util.Date recordDate, String salesSlipCd)
			throws SystemException {

		StringBuilder nullValiableArguments = new StringBuilder();
		String separator = "";

		// nullを許容しない変数に対してnullチェックをかける
		if (customerCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("customerCd");
			separator = ", ";
		}
		if (productCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("productCd");
			separator = ", ";
		}
		if (salesSlipCd == null) {
			nullValiableArguments.append(separator);
			nullValiableArguments.append("salesSlipCd");
			separator = ", ";
		}
		if (nullValiableArguments.length() > 0) {
			throw new IllegalArgumentException(EBMessageBundle.getMessage(
					"dao.IllegalArgumentException", nullValiableArguments
							.toString(),
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.updateEbSSalesSlip"));
		}

		StringBuilder key = new StringBuilder();
		List<IValueTypeBinder> params = new ArrayList<IValueTypeBinder>();

		if (salesDate != null) {
			params.add(new StringValueTypeBinder(salesDate));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		params.add(new StringValueTypeBinder(customerCd));

		params.add(new StringValueTypeBinder(productCd));

		if (productSalesAmount != null) {
			params.add(new StringValueTypeBinder(productSalesAmount));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertUserId != null) {
			params.add(new StringValueTypeBinder(insertUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (recordUserId != null) {
			params.add(new StringValueTypeBinder(recordUserId));
		} else {
			params.add(new StringValueTypeBinder(null));
		}
		if (insertDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(insertDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		if (recordDate != null) {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(recordDate)));
		} else {
			params.add(new StringValueTypeBinder(SimpleDataTypeConverter
					.convertDateToString(null)));
		}
		params.add(new StringValueTypeBinder(salesSlipCd));
		key.append("0");

		String sql = updateEbSSalesSlipSqlMap.get(key.toString());

		try {
			return jdbcManager.execute(getConnection(), sql, params);
		} catch (SQLException e) {
			throw new SystemException(EBMessageBundle.getMessage(
					"dao.SystemException",
					"jp.co.intra_mart.product.eb.sample.simplesales",
					"dm.eb_s_sales_slip.updateEbSSalesSlip", sql), e);
		}

	}
}
