package jp.co.intra_mart.product.eb.sample.simplesales.dm;

import java.io.Serializable;

import java.util.Date;
/**
 * 売上伝票
 */
public class EbSSalesSlip implements Serializable{

	/**
	 * serialVersionUID
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * 伝票コード
	 */
	private String salesSlipCd;

	/**
	 * 売上日
	 */
	private String salesDate;

	/**
	 * 得意先コード
	 */
	private String customerCd;

	/**
	 * 商品コード
	 */
	private String productCd;

	/**
	 * 商品売上数
	 */
	private String productSalesAmount;

	/**
	 * 登録ユーザID
	 * データを追加したユーザ
	 */
	private String insertUserId;

	/**
	 * 更新ユーザID
	 * データを更新したユーザ
	 */
	private String recordUserId;

	/**
	 * 登録日
	 * 登録した日です
	 */
	private Date insertDate = new Date();

	/**
	 * 更新日
	 * 更新した日です
	 */
	private Date recordDate = new Date();

	/**
	 * 伝票コードを設定します。
	 * @param salesSlipCd 伝票コード
	 */
	public void setSalesSlipCd(String salesSlipCd) {
		this.salesSlipCd = salesSlipCd;
	}

	/**
	 * 伝票コードを取得します。
	 * @return 伝票コード
	 */
	public String getSalesSlipCd() {
		return this.salesSlipCd;
	}

	/**
	 * 売上日を設定します。
	 * @param salesDate 売上日
	 */
	public void setSalesDate(String salesDate) {
		this.salesDate = salesDate;
	}

	/**
	 * 売上日を取得します。
	 * @return 売上日
	 */
	public String getSalesDate() {
		return this.salesDate;
	}

	/**
	 * 得意先コードを設定します。
	 * @param customerCd 得意先コード
	 */
	public void setCustomerCd(String customerCd) {
		this.customerCd = customerCd;
	}

	/**
	 * 得意先コードを取得します。
	 * @return 得意先コード
	 */
	public String getCustomerCd() {
		return this.customerCd;
	}

	/**
	 * 商品コードを設定します。
	 * @param productCd 商品コード
	 */
	public void setProductCd(String productCd) {
		this.productCd = productCd;
	}

	/**
	 * 商品コードを取得します。
	 * @return 商品コード
	 */
	public String getProductCd() {
		return this.productCd;
	}

	/**
	 * 商品売上数を設定します。
	 * @param productSalesAmount 商品売上数
	 */
	public void setProductSalesAmount(String productSalesAmount) {
		this.productSalesAmount = productSalesAmount;
	}

	/**
	 * 商品売上数を取得します。
	 * @return 商品売上数
	 */
	public String getProductSalesAmount() {
		return this.productSalesAmount;
	}

	/**
	 * 登録ユーザIDを設定します。
	 * @param insertUserId 登録ユーザID
	 */
	public void setInsertUserId(String insertUserId) {
		this.insertUserId = insertUserId;
	}

	/**
	 * 登録ユーザIDを取得します。
	 * @return 登録ユーザID
	 */
	public String getInsertUserId() {
		return this.insertUserId;
	}

	/**
	 * 更新ユーザIDを設定します。
	 * @param recordUserId 更新ユーザID
	 */
	public void setRecordUserId(String recordUserId) {
		this.recordUserId = recordUserId;
	}

	/**
	 * 更新ユーザIDを取得します。
	 * @return 更新ユーザID
	 */
	public String getRecordUserId() {
		return this.recordUserId;
	}

	/**
	 * 登録日を設定します。
	 * @param insertDate 登録日
	 */
	public void setInsertDate(Date insertDate) {
		this.insertDate = insertDate;
	}

	/**
	 * 登録日を取得します。
	 * @return 登録日
	 */
	public Date getInsertDate() {
		return this.insertDate;
	}

	/**
	 * 更新日を設定します。
	 * @param recordDate 更新日
	 */
	public void setRecordDate(Date recordDate) {
		this.recordDate = recordDate;
	}

	/**
	 * 更新日を取得します。
	 * @return 更新日
	 */
	public Date getRecordDate() {
		return this.recordDate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	 @Override
	public String toString() {
		StringBuilder result = new StringBuilder(super.toString());
		result.append("(salesSlipCd: ");
		result.append(salesSlipCd);
		result.append(", salesDate: ");
		result.append(salesDate);
		result.append(", customerCd: ");
		result.append(customerCd);
		result.append(", productCd: ");
		result.append(productCd);
		result.append(", productSalesAmount: ");
		result.append(productSalesAmount);
		result.append(", insertUserId: ");
		result.append(insertUserId);
		result.append(", recordUserId: ");
		result.append(recordUserId);
		result.append(", insertDate: ");
		result.append(insertDate);
		result.append(", recordDate: ");
		result.append(recordDate);
		result.append(")");
		return result.toString();
	}
}